export default {
  data () {
    return {
      selectedChannels: []
    }
  },
  watch: {
    channels (newChannels) {
      // Remove channels that were unsubscribed from selected channels
      this.selectedChannels = this.selectedChannels.filter(selChannel => newChannels.some(subChannel => subChannel.name === selChannel.name))
    }
  },
  computed: {
    channels () {
      const channelsDict = this.$store.state.channelModule.sourceDict
      return Object.entries(channelsDict).flatMap(source => {
        return source[1].channels.map(channel => ({
          id: [source[0], channel.id],
          name: channel.name
        }))
      })
    }
  }
}
