const savedLayouts = 'savedLayouts'
const lastSelectionKey = 'lastSelection'

let savedLayoutsDict = () => {
  let rawSavedLayouts = localStorage.getItem(savedLayouts)
  if (rawSavedLayouts !== undefined && rawSavedLayouts !== null) {
    try {
      return JSON.parse(rawSavedLayouts)
    } catch (error) {
      console.log(error)
      return {}
    }
  } else {
    return {}
  }
}

function getLayoutIds () {
  return Object.keys(savedLayoutsDict())
}

function saveLayout ({ id, newLayout }) {
  // Make an empty layoutDict if the original is undefined
  let layoutDict = savedLayoutsDict() || {}
  layoutDict[id] = newLayout
  localStorage.setItem(savedLayouts, JSON.stringify(layoutDict))
}

function deleteLayout (layoutId) {
  let layoutDict = savedLayoutsDict()
  delete layoutDict[layoutId]
  localStorage.setItem(savedLayouts, JSON.stringify(layoutDict))
  return Object.keys(layoutDict)[0]
}
function getLayoutById (id) {
  return savedLayoutsDict() ? savedLayoutsDict()[id] : undefined
}

function saveSelection (layoutId) {
  localStorage.setItem(lastSelectionKey, JSON.stringify(layoutId))
}

function getLastSelection () {
  const lastSelectedLayout = localStorage.getItem(lastSelectionKey)
  if (!lastSelectedLayout) {
    return false
  }
  try {
    return JSON.parse(lastSelectedLayout)
  }
  catch (e) {
    return ''
  }
}

function layoutExists (id) {
  return this.getLayoutById(id) !== undefined
}

export default {
  saveSelection, saveLayout, getLastSelection, getLayoutById, getLayoutIds, deleteLayout, layoutExists
}
