export const channelModule = {
  namespaced: true,
  state: {
    // Dictionary of sourceIDs, example:
    /* sourceDict: {
      0000: {
        byteFormat: '<dddddddddd'
        name: 'testrig',
        channels: [
          {
            id: 1,
            name: 'Load [N]'
          }
        ]
      }
    } */
    sourceDict: {}
  },
  mutations: {
    setSourceDict (state, newDict) {
      state.sourceDict = newDict
    }
  },
  actions: {
    generateDataSources ({ commit, state }, dataSources) {
      let newSourceDict = {}
      dataSources.forEach((source) => {
        const channels = source.subscribedChannels
        let newChannels = []
        for (let i = 0; i < channels.length; i++) {
          const channelName = channels[i].channelName
          const id = channels[i].id
          newChannels.push({
            id: id,
            name: channelName
          })
        }
        newSourceDict[source.id] = {
          name: source.name,
          byteFormat: source.byteFormat,
          channels: newChannels
        }
      })
      commit('setSourceDict', newSourceDict)
    }
  }
}
