// Create download dialog for currently plotted data
exports.save = (channel) => {
  const layout = channel.channelLayout
  const channelData = channel.channelData
  var saveData = layout.xaxis.title + ', ' + layout.yaxis.title + '\r\n'
  for (var i = 0; i < channelData.x.length; i++) {
    saveData += channelData.x[i].valueOf() + ', ' + channelData.y[i] + '\r\n'
  }
  this.download(saveData, 'twin_' + new Date().toISOString() + '.csv', 'text/csv')
}

// Downloading data to a file
exports.download = (data, filename, type) => {
  var file = new Blob([data], { type: type })
  if (window.navigator.msSaveOrOpenBlob) // IE10+
  { window.navigator.msSaveOrOpenBlob(file, filename) } else { // Others
    var a = document.createElement('a')

    var url = URL.createObjectURL(file)
    a.href = url
    a.download = filename
    document.body.appendChild(a)
    a.click()
    setTimeout(function () {
      document.body.removeChild(a)
      window.URL.revokeObjectURL(url)
    }, 0)
  }
}
